import os
import sys

__dir__ = os.path.dirname(os.path.abspath(__file__))
sys.path.append(__dir__)
sys.path.append(os.path.abspath(os.path.join(__dir__, '../..')))

import cv2
import difflib
import time
from moviepy.editor import VideoFileClip, TextClip, CompositeVideoClip
import tools.infer.predict_system as predict_system
import tools.infer.utility as utility
import tools.translate.translate as translate

def moviecut(videoPath='./test.mp4'):
    img = []
    video = cv2.VideoCapture(videoPath)

    if video.isOpened():
        timeF = 15  # 采样间隔，每隔timeF帧提取一张图片
        count = 1
        success = True
        while (success):
            success, frame = video.read()
            if (count % timeF == 0):
                img.append(frame)
            count += 1
            cv2.waitKey(1)
        video.release()
        print("open ok")
        return img
    else:
        print("open error")
        exit(0)

def movie2text():
    old_trans_str = ''
    # f = open('./txt/original.txt', 'w')
    text = []

    img = moviecut(videoPath='./test.mp4')
    for i in range(len(img)):
        cv2.imwrite('./infer.jpg', img[i])
        new_trans_str = predict_system.main(utility.parse_args())
        if len(new_trans_str) != 0:
            new_trans_str = new_trans_str[0]
            print(difflib.SequenceMatcher(None, new_trans_str, old_trans_str).quick_ratio())
            if(difflib.SequenceMatcher(None, new_trans_str, old_trans_str).quick_ratio()<0.85):
                old_trans_str = new_trans_str
                # f.write(new_trans_str+' '+str(i)+'\n')
                text.append(new_trans_str+';'+str(i))
    # f.close()
    return text

def puttext(videoPath='./test.mp4', transPath='./txt/trans.txt'):
    video = VideoFileClip(videoPath)
    width, height = video.w, video.h
    trans_text = []

    with open(transPath, encoding='utf-8') as f:
        for line in f:
            trans_sentence, start, span = line.split(',')
            start, span = map(float, (start, span))
            trans_txt = TextClip(trans_sentence, fontsize=25,
                                 font='SimHei', size=(width-20, 25),
                                 align='center', color='white').set_position((10,height-40)).set_duration(span).set_start(start)
            trans_text.append(trans_txt)

    video = CompositeVideoClip([video, *trans_text])
    video.write_videofile('one.mp4')


if __name__ == '__main__':
    a = movie2text()
    print(a)
    b = []
    for i in range(len(a)):
        origin_txt, last_time = a[i].split(';')[0], a[i].split(';')[1]
        txt = translate.main(origin_txt)
        print(txt)
        if txt != None:
            if i != len(a)-1:
                dur_time = a[i+1].split(';')[1]
                b.append(txt + ',' + str(float(last_time)*15/30) + ',' + str((float(dur_time)-float(last_time))*15/30))
            else:
                b.append(txt + ',' + str(float(last_time)*15/30) + ',' + str(1))
        time.sleep(1)

    print(b)
    f = open('./txt/trans.txt', 'w', encoding='utf-8')
    for i in b:
        f.write(i+'\n')
    f.close()
    puttext()

    # movie2text()