import os
import sys

__dir__ = os.path.dirname(os.path.abspath(__file__))
sys.path.append(__dir__)
sys.path.append(os.path.abspath(os.path.join(__dir__, '../..')))

import tkinter
import tkinter.filedialog
import tools.infer.predict_system as predict_system
import tools.infer.utility as utility
import tools.translate.translate as translate


def run(pic_txt, trans_txt):
    text_str = predict_system.main(utility.parse_args())
    picture_txt = ''
    for txt in text_str:
        picture_txt = picture_txt + txt
    pic_txt.delete(0.0, tkinter.END)
    pic_txt.insert(tkinter.END, picture_txt)
    trans_txt.delete(0.0, tkinter.END)
    trans_txt.insert(tkinter.END, translate.main(picture_txt))


if __name__ == '__main__':
    root = tkinter.Tk()
    root.geometry('500x320')
    root.title('paddleocr')
    # 输出文本框1
    pic_txt = tkinter.Text(root, font=('华文新魏', 11))
    pic_txt.place(relx=0.03, rely=0.03, relwidth=0.95, relheight=0.4)
    # 输出文本框2
    trans_txt = tkinter.Text(root, font=('华文新魏', 11))
    trans_txt.place(relx=0.03, rely=0.47, relwidth=0.95, relheight=0.4)
    button = tkinter.Button(root, font=('华文新魏', 11), text='开始', background='#CA0316', foreground='white',
                    activebackground='red',
                    activeforeground='white', command=lambda:run(pic_txt, trans_txt))
    button.place(relx=0.45, rely=0.9, relwidth=0.1, relheight=0.07)
    root.mainloop()
